@using Entities
@using Business
@using DataAccess


@inject IDbContextFactory<inventory_context> ContextFactory


@if (DataLoading)
{
    <h4>@loading_message</h4>
}

<div>
    <table class="table table-hover table-bordered">
        <thead>
            <tr>
                <th>Category ID</th>
                <th>Category Code</th>
                <th>Category Name</th>
                <th>Actions</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var category in categories)
            {
                <tr>
                    <td>@category.CatId</td>
                    <td>@category.CatCode</td>                
                    <td>@category.CatName</td>
                    <td>
                        <a href="category/edit/@category.CatId">
                            <button class="btn btn-primary">Editar</button>
                        </a>                       
                    </td>    
                </tr>                
            }
        </tbody>

    </table>

</div>



@code
{
    private bool DataLoading = false;
    private string loading_message = "Fetching categories from DB ...";
    List<Category> categories = new();

    B_Category bCategory = null!;

        protected override async Task OnInitializedAsync()
        {
            if (DataLoading)
            {
                return;
            }
            try
            {
                DataLoading = true;

                bCategory = new (ContextFactory);

                if (bCategory is not null)
                {
                    categories = await bCategory.GetCategories();
                }
                
            }
            catch (System.Exception ex)
            {
                throw ex;
            }
            finally
            {
                DataLoading = false;    
            }
            await base.OnInitializedAsync();
        }



    
}